chiark / gitweb /
Test suite: Make t-expect-push-fail out of the remains of mustfail
[dgit.git] / tests / lib
index 0e188cca4280e83cf1f3de309198901c226b8cf7..f45dd0b2bb80ecbdec39807d471cac72bf2f531d 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -2,6 +2,7 @@
 
 exec 2>&1
 set -x
+set -o pipefail
 
 . tests/lib-core
 
@@ -24,14 +25,14 @@ fi
 cd $tmp
 
 tmp=`pwd`
-export HOME=$tmp
-export DGIT_TEST_DUMMY_DIR=$tmp
+
+t-set-using-tmp
+
 ln -f $troot/ssh ssh
 
 mkdir -p $tmp/gnupg
 cp $troot/gnupg/* $tmp/gnupg
 chmod go-rw $tmp/gnupg/*
-export GNUPGHOME=$tmp/gnupg
 
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
@@ -43,9 +44,51 @@ END
 
 t-expect-fail () {
        local mpat="$1"; shift
+
+       local grepper=fgrep
+       case "$mpat" in
+       [A-Z]:*)
+               case "$mpat" in
+               E:*)    grepper=egrep   ;;
+               F:*)    grepper=fgrep   ;;
+               *)      fail "bad mpat prefix in $mpat";;
+               esac
+               mpat=${mpat#[A-Z]:}
+               ;;
+       esac
+
+       set +o pipefail
        LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
-       test ${PIPESTATUS[0]} != 0
-       egrep "$mpat" $tmp/t.output ||false
+       local ps="${PIPESTATUS[*]}"
+       set -o pipefail
+
+       case $ps in
+       "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
+       *" 0")  ;;
+       *)      fail "tee failed"  ;;
+       esac
+
+       $grepper -e "$mpat" $tmp/t.output ||
+               fail "error message not found"
+}
+
+t-expect-push-fail () {
+       local mpat="$1"; shift
+       t-reporefs pre-push
+       t-expect-fail "$mpat"  "$@"
+       t-reporefs post-push
+       diff $tmp/show-refs.{pre,post}-push
+}
+
+t-reporefs () {
+       local whichoutput=$1; shift
+       local outputfile="$tmp/show-refs.$whichoutput"
+       (set -e
+        exec >"$outputfile"
+        if test -d $tmp/git/$p.git; then
+               cd $tmp/git/$p.git
+               git show-ref |sort
+       fi)
 }
 
 t-untar () {
@@ -90,23 +133,27 @@ t-prep-newpackage () {
        v=$2
        t-archive-none $p
        t-git-none
-       v=3-1
        t-worktree $v
        cd $p
-       git branch -m dgit/sid master
-       git remote rm dgit
+       if ! git-show-ref --verify --quiet refs/heads/master; then
+               git branch -m dgit/sid master
+               git remote rm dgit
+       fi
        cd ..
 }
 
 t-archive-none () {
        p=$1
        mkdir -p $tmp/aq $tmp/mirror/pool/main
-       mkdir -p $tmp/aq/dsc_in_suite $tmp/aq/dsc_in_suite/sid
 
        local suite=sid
+
        >$tmp/aq/package.$suite.$p
        t-archive-updated $suite $p
 
+       >$tmp/aq/package.new.$p
+       t-archive-updated new $p
+
        ln -s sid $tmp/aq/dsc_in_suite/unstable
        cat <<'END' >$tmp/aq/suites
 [
@@ -128,7 +175,9 @@ END
 t-archive-updated () {
        local suite=$1
        local p=$2
-       perl <$tmp/aq/package.$suite.$p >$tmp/aq/dsc_in_suite/$suite/$p -wne '
+       local suitedir=$tmp/aq/dsc_in_suite/$suite
+       mkdir -p $suitedir
+       perl <$tmp/aq/package.$suite.$p >$suitedir/$p -wne '
                use JSON;
                use strict;
                our @v;
@@ -146,15 +195,17 @@ t-archive-updated () {
 }
 
 t-archive-process-incoming () {
-       mv incoming/${p}_${v}[._]* mirror/pool/main/
-       t-archive-query
+       local suite=$1
+       mv $tmp/incoming/${p}_${v}[._]* $tmp/mirror/pool/main/
+       t-archive-query "$suite"
 }
 
 t-archive-query () {
+       local suite=${1-sid}
        local dscf=main/${p}_${v}.dsc
-       local sha=`sha256sum <mirror/pool/$dscf`
-       echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.sid.${p}
-       t-archive-updated sid $p
+       local sha=`sha256sum <$tmp/mirror/pool/$dscf`
+       echo "${v} ${sha%  -} $dscf" >>$tmp/aq/package.$suite.${p}
+       t-archive-updated $suite $p
 }
 
 t-archive () {
@@ -169,6 +220,32 @@ t-archive () {
        (set -e; cd $tmp/extract; dpkg-source -x ../mirror/pool/main/$dscf)
 }
 
+t-git-dir-time-passes () {
+       touch -d 'last year' $tmp/git/$p.git
+}
+
+t-git-dir-check () {
+       local gitdir=$tmp/git/$p.git
+       case "$1" in
+       enoent)
+               if test -e "$gitdir"; then fail "$gitdir exists"; fi
+               return
+               ;;
+       public) wantstat='7[75]5' ;;
+       secret) wantstat='7[70]0' ;;
+       *)      fail "$1 t-git-dir-check ?" ;;
+       esac
+       gotstat=`stat -c%a $gitdir`
+       case "$gotstat" in
+       *$wantstat) return ;;
+       *)      fail "$gitdir has mode $gotstat, expected $wantstat" ;;
+       esac
+}
+
+t-rm-dput-dropping () {
+       rm -f $tmp/${p}_${v}_*.upload
+}
+
 t-dgit () {
        local dgit=${DGIT_TEST-dgit}
        : '
@@ -191,7 +268,7 @@ t-cloned-fetched-good () {
        t-refs-same \
                refs/heads/dgit/sid \
                refs/remotes/dgit/dgit/sid
-       t-refs-notexist dgit/unstable remotes/dgit/dgit/unstable
+       t-refs-notexist refs/dgit/unstable refs/remotes/dgit/dgit/unstable
 }
 
 t-output () {
@@ -207,7 +284,11 @@ t-clean-on-branch () {
 
 t-git-get-ref () {
        local ref=$1
-       git show-ref -d $1 | perl -ne '
+       case "$ref" in
+       refs/*) ;;
+       *) fail "t-git-get-ref bad $ref" ;;
+       esac
+       (git show-ref -d $1 || test $? = 1) | perl -ne '
                $x = $1 if m#^(\w+) \Q'$1'\E(?:\^\{\})?$#;
                END { print "$x\n" if length $x; }
        '
@@ -293,6 +374,35 @@ t-822-field () {
        ' <$file
 }
 
+t-stunt-envvar () {
+       local var=$1
+       local tstunt=$2
+       eval '
+               case "'$var'" in
+               "$tstunt:"*)    ;;
+               *":$tstunt:"*)  ;;
+               *)              '$var'="$tstunt:$'$var'" ;;
+               esac
+       '
+}
+
+t-tstunt () {
+       local tstunt=$tmp/tstunt
+       t-stunt-envvar PATH $tstunt
+       t-stunt-envvar PERLLIB $tstunt
+       local f
+       for f in "$@"; do
+               f="./$f"
+               local d="$tstunt/${f%/*}"
+               mkdir -p $d
+               ln -sf "$troot/tstunt/$f" "$d"/.
+       done
+}
+
+t-tstunt-parsechangelog () {
+       t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
+}
+
 t-ref-dsc-dgit () {
        local dsc=${p}_${v}.dsc
        local val=`t-822-field $tmp/incoming/$dsc Dgit`
@@ -303,8 +413,18 @@ t-ref-dsc-dgit () {
 t-apply-diff () {
        local v1=$1
        local v2=$2
-       (cd $troot/pkg-srcs; debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc) \
-               | patch -p1 -u
+       (cd $troot/pkg-srcs;
+        debdiff ${p}_${v1}.dsc ${p}_${v2}.dsc || test $? = 1) \
+        | patch -p1 -u
+}
+
+t-commit () {
+       local msg=$1
+       v=1.$revision
+       dch -v$v --distribution unstable "$1"
+       git add debian/changelog
+       debcommit
+       revision=$(( $revision + 1 ))
 }
 
 t-git-config () {
@@ -313,7 +433,6 @@ t-git-config () {
 
 t-drs () {
        export DGIT_TEST_TROOT=$troot
-       export DGIT_TEST_TMP=$tmp
  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
  t-git-config dgit-distro.test-dummy.git-check true
  t-git-config dgit-distro.test-dummy.git-create true
@@ -352,16 +471,25 @@ t-policy-admin () {
        ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
 }
 
+t-policy () {
+       local policyhook=$1
+       ln -sf ${DGIT_INFRA_PFX}$policyhook \
+               $drs_dispatch/policy-hook
+}
+
 t-debpolicy () {
        t-dsd
-
-       ln -sf ${DGIT_INFRA_PFX}dgit-repos-policy-debian \
-               $drs_dispatch/policy-hook
+       t-policy dgit-repos-policy-debian
 
        mkdir $tmp/git
        t-policy-admin create-db
 }
 
+t-policy-periodic () {
+       ${DGIT_REPOS_SERVER_TEST-dgit-repos-server} \
+               test-dummy $drs_dispatch '' --cron
+}
+
 t-chain-test () {
        local ct=$1
        local d=${0%/*}